// zunpack2.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
//#include "zvitunpack.cpp"

#include <windows.h>
#include <winnls.h>
//#include <shlwapi.h>
#include <wchar.h>
#include "LzmaDec.h"
#include "Alloc.h"
#include "Strsafe.h"
static void *SzAlloc(void *p, size_t size) { p = p; return MyAlloc(size); }
static void SzFree(void *p, void *address) { p = p; MyFree(address); }
static ISzAlloc g_Alloc = { SzAlloc, SzFree };

void mainproc()
{
	HANDLE hFile;
	DWORD dwHiSize = NULL, dwLoSize = NULL;
	LPBYTE lpbInBuff = NULL, lpbOutBuff = NULL;
	BYTE xorStr[16] = {0x0E8, 0x0D5, 1, 3, 0x0C3, 0x0C1, 0x83, 0x3D, 0x0B7, 0x0F0, 0x41, 5, 7, 0x72, 0x10, 0x0E8};
	ELzmaStatus LzmaStatus;

	LPWSTR lpstrOutFile = NULL;
	LPWSTR lpwstrMsg = (LPWSTR)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, 512 * sizeof(WCHAR));
	LPWSTR lpwstrErr = (LPWSTR)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, 256 * sizeof(WCHAR));
	int argc = 0;
	DWORD dwError = NULL;

	char szPACKED_XML[] = "PACKED_XML";
    int n;

	//    
	LPWSTR lpstrCmndLine = GetCommandLineW();
	LPWSTR *argv = CommandLineToArgvW(lpstrCmndLine, &argc);
	//LPCWSTR *errv = TEXT("Error");

	// ,  
	if(argc != 2)
	{
		MessageBoxA(NULL, ("Usage:\nzunpack.exe <full name of xml-file>"), "Error", MB_OK|MB_ICONERROR|MB_SYSTEMMODAL);
		ExitProcess(1);
	}



	//  .  
	hFile = CreateFileW(argv[1], GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, NULL, NULL);
	if(hFile == INVALID_HANDLE_VALUE)
	{
		//  
		dwError = GetLastError();
		FormatMessageW(FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_MAX_WIDTH_MASK, NULL, dwError, LANG_SYSTEM_DEFAULT, lpwstrErr, 255, NULL);
		StringCbPrintfW(lpwstrMsg,512 * sizeof(WCHAR),L"Can't open file \"%s\"\nError: %s (%X)",argv[1], lpwstrErr, dwError);
		//wsprintfW(lpwstrMsg, L"Can't open file \"%s\"\nError: %s (%X)", argv[1], lpwstrErr, dwError);
		MessageBoxW(NULL, lpwstrMsg, L"Error", MB_ICONERROR|MB_OK|MB_SYSTEMMODAL);
		ExitProcess(1);
	}

	dwLoSize = GetFileSize(hFile, &dwHiSize);
	if(dwLoSize == 0xFFFFFFFF && (dwError = GetLastError()) != NO_ERROR)
	{
		//  
		FormatMessageW(FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_MAX_WIDTH_MASK, NULL, dwError, LANG_SYSTEM_DEFAULT, lpwstrErr, 255, NULL);
		StringCbPrintfW(lpwstrMsg,512 * sizeof(WCHAR),L"Can't get size of the file \"%s\"\nError: %s (%X)",argv[1], lpwstrErr, dwError);
		//wsprintfW(lpwstrMsg, L"Can't get size of the file \"%s\"\nError: %s (%X)", argv[1], lpwstrErr, dwError);
		MessageBoxW(NULL, lpwstrMsg, L"Error", MB_ICONERROR|MB_OK|MB_SYSTEMMODAL);
		ExitProcess(1);
	}
	if(dwHiSize)
	{
		StringCbPrintfW(lpwstrMsg,512 * sizeof(WCHAR), L"File \"%s\" too big",argv[1]);
		//wsprintfW(lpwstrMsg, L"File \"%s\" too big", argv[1]);
		MessageBoxW(NULL, lpwstrMsg, L"Error", MB_ICONERROR|MB_OK|MB_SYSTEMMODAL);
		ExitProcess(1);
	}

	lpbInBuff = (LPBYTE)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, dwLoSize);
	if(!lpbInBuff)
	{
		//  
		dwError = GetLastError();
		FormatMessageW(FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_MAX_WIDTH_MASK, NULL, dwError, LANG_SYSTEM_DEFAULT, lpwstrErr, 255, NULL);
		StringCbPrintfW(lpwstrMsg,512 * sizeof(WCHAR),L"Can't allocate %d byte\nError: %s (%X)", dwLoSize, lpwstrErr, dwError);
		//wsprintfW(lpwstrMsg, L"Can't allocate %d byte\nError: %s (%X)", dwLoSize, lpwstrErr, dwError);
		MessageBoxW(NULL, lpwstrMsg, L"Error", MB_ICONERROR|MB_OK|MB_SYSTEMMODAL);
		ExitProcess(1);
	}

	if(!ReadFile(hFile, lpbInBuff, dwLoSize, &dwHiSize, NULL))
	{
		//  
		dwError = GetLastError();
		FormatMessageW(FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_MAX_WIDTH_MASK, NULL, dwError, LANG_SYSTEM_DEFAULT, lpwstrErr, 255, NULL);
		StringCbPrintfW(lpwstrMsg,512 * sizeof(WCHAR), L"Can't read of the file \"%s\"\nError: %s (%X)", argv[1], lpwstrErr, dwError);
		//wsprintfW(lpwstrMsg, L"Can't read of the file \"%s\"\nError: %s (%X)", argv[1], lpwstrErr, dwError);
		MessageBoxW(NULL, lpwstrMsg, L"Error", MB_ICONERROR|MB_OK|MB_SYSTEMMODAL);
		ExitProcess(1);
	}

	CloseHandle(hFile);

	//    xml'

	n=memcmp ( szPACKED_XML, (LPSTR)lpbInBuff, 10 );

	//if(StrCmpNA("PACKED_XML", (LPSTR)lpbInBuff, 10))
    if(n!=0)
	{
		StringCbPrintfW(lpwstrMsg,512 * sizeof(WCHAR), L"The file \"%s\" is not a xml packed by Best-Zvit+", argv[1]);
		//wsprintfW(lpwstrMsg, L"The file \"%s\" is not a xml packed by Best-Zvit+", argv[1]);
		MessageBoxW(NULL, lpwstrMsg, L"Error", MB_ICONERROR|MB_OK|MB_SYSTEMMODAL);
		ExitProcess(1);
	}

	//    
	dwHiSize = *(LPDWORD)(lpbInBuff + 11);

	// xor'  160  .  
	for(int count = 0; count < 160; count++)
		*(lpbInBuff + 15 + count) ^= *(xorStr + count % 16);



	//    . 
	lpstrOutFile = (LPWSTR)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, (lstrlenW(argv[1]) + 2 )* sizeof(WCHAR));
	//StrCpyNW(lpstrOutFile, argv[1], lstrlenW(argv[1]) + 1);
	StringCbCopyNW(lpstrOutFile,(lstrlenW(argv[1]) + 2 )* sizeof(WCHAR),argv[1],(lstrlenW(argv[1]) + 1)* sizeof(WCHAR));
	*(lpstrOutFile + lstrlenW(argv[1])) = L'_';

	
	hFile = CreateFileW(lpstrOutFile, GENERIC_WRITE, NULL, NULL, CREATE_ALWAYS, NULL, NULL);
	if(hFile == INVALID_HANDLE_VALUE)
	{
		//  
		dwError = GetLastError();
		FormatMessageW(FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_MAX_WIDTH_MASK, NULL, dwError, LANG_SYSTEM_DEFAULT, lpwstrErr, 255, NULL);
		StringCbPrintfW(lpwstrMsg,512 * sizeof(WCHAR), L"Can't open file \"%s\"\nError: %s (%X)", lpstrOutFile, lpwstrErr, dwError);
		//wsprintfW(lpwstrMsg, L"Can't open file \"%s\"\nError: %s (%X)", lpstrOutFile, lpwstrErr, dwError);
		MessageBoxW(NULL, lpwstrMsg, L"Error", MB_ICONERROR|MB_OK|MB_SYSTEMMODAL);
		ExitProcess(1);
	}

	lpbOutBuff = (LPBYTE)HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, dwHiSize);
	if(!lpbOutBuff)
	{
		//  
		dwError = GetLastError();
		FormatMessageW(FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_MAX_WIDTH_MASK, NULL, dwError, LANG_SYSTEM_DEFAULT, lpwstrErr, 255, NULL);
		StringCbPrintfW(lpwstrMsg,512 * sizeof(WCHAR), L"Can't allocate %d byte\nError: %s (%X)", dwLoSize, lpwstrErr, dwError);
		//wsprintfW(lpwstrMsg, L"Can't allocate %d byte\nError: %s (%X)", dwLoSize, lpwstrErr, dwError);
		MessageBoxW(NULL, lpwstrMsg, L"Error", MB_ICONERROR|MB_OK|MB_SYSTEMMODAL);
		ExitProcess(1);
	}

	//  
	dwLoSize -= 24 + LZMA_PROPS_SIZE;
	if(LzmaDecode(lpbOutBuff, (SizeT *) &dwHiSize, lpbInBuff + 24 + LZMA_PROPS_SIZE, (SizeT *) &dwLoSize, 
		lpbInBuff + 16, LZMA_PROPS_SIZE, LZMA_FINISH_ANY, &LzmaStatus, &g_Alloc) != SZ_OK)
	{
		//  
		dwError = GetLastError();
		MessageBoxW(NULL, L"Can't unpack", L"Error", MB_ICONERROR|MB_OK|MB_SYSTEMMODAL);
	}

	//  .
	if(!WriteFile(hFile, lpbOutBuff, dwHiSize, &dwError, NULL))
	{
		//  
		dwError = GetLastError();
		FormatMessageW(FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_MAX_WIDTH_MASK, NULL, dwError, LANG_SYSTEM_DEFAULT, lpwstrErr, 255, NULL);
		StringCbPrintfW(lpwstrMsg,512 * sizeof(WCHAR), L"Can't write file \"%s\"\nError: %s (%X)", lpstrOutFile, lpwstrErr, dwError);
		//wsprintfW(lpwstrMsg, L"Can't write file \"%s\"\nError: %s (%X)", lpstrOutFile, lpwstrErr, dwError);
		MessageBoxW(NULL, lpwstrMsg, L"Error", MB_ICONERROR|MB_OK|MB_SYSTEMMODAL);
		ExitProcess(1);
	}

	CloseHandle(hFile);
	HeapFree(GetProcessHeap(), HEAP_NO_SERIALIZE, lpwstrErr);
	HeapFree(GetProcessHeap(), HEAP_NO_SERIALIZE, lpwstrMsg);
	HeapFree(GetProcessHeap(), HEAP_NO_SERIALIZE, lpbInBuff);
	HeapFree(GetProcessHeap(), HEAP_NO_SERIALIZE, lpbOutBuff);
	HeapFree(GetProcessHeap(), HEAP_NO_SERIALIZE, lpstrOutFile);


//	ExitProcess(0);
}


int _tmain(int argc, _TCHAR* argv[])
{
	mainproc();
	return 0;
}

